/*
laserspotcam        A software to track a laser pointer on a wall.
Copyright (C) 2005  Raphael Assenat

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Author: Raphael Assenat <raph@raphnet.net>
*/
#ifndef _SDL_v4l_h
#define _SDL_v4l_h

#include "SDL.h"

char SDL_v4l_setRotation(char rotation);
char SDL_v4l_toggleRotation();
char SDL_v4l_getRotation();
int SDL_v4l_getRGB32Data(unsigned char *data, unsigned long len);
int SDL_v4l_get_webcam_image_geometry(int *w, int *h);
int show_webcam_image(int X, int Y, SDL_Surface *target);
void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel);

int SDL_v4l_fetchImage();
unsigned char *SDL_v4l_get_rgb_buffer();

/**
 * Draw the last fetched image on an SDL surface.
 *
 * Prerequisite: SDL_v4l_fetchImage has been called.
 */
int SDL_v4l_blitBuffer(int X, int Y, SDL_Surface *target);

#endif
