/*
laserspotcam        A software to track a laser pointer on a wall.
Copyright (C) 2005  Raphael Assenat

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Author: Raphael Assenat <raph@raphnet.net>
*/


/**
 * Operates on a RGB32 buffer.
 */
void filter_redness(char *buffer, int w, int h)
{
	int len;
	unsigned char val;
	unsigned char *b=buffer;

	len = w*h;

	do {
		// take the red component, and substract the other ones
		// from it.
		val = b[2] - ( (b[1]+b[0])*b[2])/512;
		b[0] = b[1] = b[2] = val;
		b += 4;
	} while(--len);
		
}

void filter_keep_red(char *buffer, int w, int h)
{
	int len;
	unsigned char val;
	unsigned char *b=buffer;

	len = w*h;

	do {
		val = b[2];
		b[0] = b[1] = b[2] = val;
		b += 4;
	} while(--len);

}

void filter_keep_green(char *buffer, int w, int h)
{
	int len;
	unsigned char val;
	unsigned char *b=buffer;

	len = w*h;

	do {
		val = b[1];
		b[0] = b[1] = b[2] = val;
		b += 4;
	} while(--len);

}

void filter_keep_blue(char *buffer, int w, int h)
{
	int len;
	unsigned char val;
	unsigned char *b=buffer;

	len = w*h;

	do {
		val = b[0];
		b[0] = b[1] = b[2] = val;
		b += 4;
	} while(--len);

}

void filter_threshold(char *buffer, int w, int h, int value)
{
	int len;
	unsigned char *b=buffer;

	len = w*h;

	do {
		if (*b > value) { *b = 255; } else { *b = 0; } // red
		b++;
	} while(--len);

}

