/*
laserspotcam        A software to track a laser pointer on a wall.
Copyright (C) 2005  Raphael Assenat

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Author: Raphael Assenat <raph@raphnet.net>
*/
#ifndef _hotspots_h__
#define _hotspots_h__

#include <sys/time.h>
#include <time.h>

typedef struct _hotspot hotspot;

#define TYPE_BASIC	0
#define TYPE_LEFT_TO_RIGHT_VALUE	1

struct _hotspot {
	int type;

	int x1, y1; // upper left corner
	int x2, y2; // lower right corner
	char *cmd;

	struct timeval last_triggered;

	
	hotspot *next;
};

hotspot *hotspot_create(int type, int x1, int y1, int x2, int y2, const char *cmd);
void hotspot_free(hotspot *hspot);

int hotspot_add(hotspot *hspot);
int hotspot_load(char *filename);

int hotspot_trig(int test_mode, hotspot *hspot, int x, int y);

hotspot *hotspot_getHead(void);

void hotspot_setVerboseSystem(int verb);

#endif

